/*************************************
 PICputer IDE 0.1.0
 (C) 2008 Hynek Sladky
 sladky@mujmail.cz
*************************************/
#include <PalmOS.h>
#include <PalmChars.h>
// ------------------------------------
// resources header
// ------------------------------------
#include "PP_IDER.h"
#include "version.h"
extern const char *build, *build_date, *build_time;
// ------------------------------------
// defines
// ------------------------------------
#define AppID           'Pide'
/******** ToDo ********/
/**********************
OPRAVY:
======
- kdyz se na progress dialogu pouzije pro Cancel prostredni tlacitko, tak se hned pote spusti zase download...
  asi zustane nekde ulozena nejaka udalost a zpracuje se...
? kdyz se zvoli EDIT nebo CANCEL, tak se cache neulozi korektne!
  pri dalsim spusteni Download to bere zbytek souboru jako nenaprogramovany!!!
  hlasi to podivne chyby: diff 0-22; 22-23; 23-24 - pak je ve zdrojaku mezera v cislovani...
  -> mozna to bylo chybou v algoritmu, pokud jsem precisloval radky -> uplne se to rozpadlo...
o kdyz jsem misto $0020 napsal $20, tak to hlasilo nesmyslne cislo radku
  zkontrolovat, zda nejsou nejak zmatene promenne!
o kdyz nedoslo ke korektnimu nacteni Cache (asi z duvodu predchozi chyby?), tak uz se to nevzpamatovalo
  pri dalsim pokusu o nacteni cache se to zacyklilo na jakesi hlasce "0-255 diff" (nebo tak nejak)

UPRAVY:
======
- po ucesani doplnit podporu pro programovai radku 0 => 2048
o hlasit chybu popleteni cisel: nove cislo je mensi nez starsi
- ucesat Download
  funkce DeleteLines, ProgLine ...
  jedina funkce pro sledovani pozice v TEMPu...
- zlepsit/sjednotit logovani + progress dialog...
  pouzivat prefs.flags a define na vsech mistech...
o pridat checkbox "run after download"
o vylepsit chybove hlasky: hlasit, co za problem se objevilo... misto nic-nerikajicich cisel...
  chyby z funkci UpdateCache, Download
- bylo by sikovne, kdyby poznalo, ze $0020 je identicke $20...
  upravit funkci bascmp...

- do budoucna by se mohly pridat scripty pro ruzne operace...
  koneckoncu by pak nemuselo byt tlacitko Run, ale rovnou vyber z listboxu scriptu
  - script Run, script Debug, script ^C, script Erase All...
  - pak se tlacitko Debug zmeni na On (mysleno terminal On/Off)
- pokud to je pozadovano, tak radek 0 lze zadat jako radek 2048!!!
- umoznit necislovat radky - automaticke cislovani
  pokud radek nema cislo, pak je to predchozi + 1
  pokud radek zacina #label, tak se v prvnim pruchodu vyhodnoti cisla takovych radku
  v druhem pruchodu se tato cisla pouziji v prikazech GOTO/GOSUB

Hotovo:
=======
o> tj. znovu si projit  funkce kolem portu a optimalizovat je (ne Download a UpdateCache, ty jsou celkem nezavisle, ale ty ostatni)
   mozna ale pouzit, pokud uz je otevreny port, tak ho znovu neotvirat
o pouzit funkci SrmSetWakeupHandler, stavajici reseni je prilis neefektivni!
  ale je potreba se zamyslet nad tim jak zablokovat znaky pri otevreni jineho okna...
o tlacitko Debug bude On/Off - pri druhem stisku (nebo pri zavreni COM portu) se musi deaktivovat
  -> napsat si pro to funkci
o funkce pro otevreni portu a 'dostani' PICputeru do znameho stavu (je to tam vickrat!)
  pokud je rozepsany prikazovy radek, tak nevim, jak to udelat...
  pokud poslu '\r', muze se stat, ze se neco provede...
  pokud poslu '\b', nemam kontrolu, kolikrat to mam poslat
  - mel bych v PICputeru kontrolovat, ze uz nemam '\b' echovat, kdyz jsem na zacatku...
    to by mohlo pomoci; ale asi zas narazim na nedostatek pameti pro instrukce...
o zrusit vyber terminalu v nastaveni (neni potreba)
o vynulovani rozpracovane prikazove radky
  o asi bude nutna nejaka podpora v PICputeru, ale zatim nemam napad, jak to udelat...
    napriklad neechovat '\b', pokud uz jsem na zacatku radku
    nebo pri prijmu ^C vynulovat radek a zacit zadavat znovu
o pri chybe se zobrazi, ze nejde vykonat clrpgm, pritom by se vykonavat nemel!!!
  asi dochazi na zacatku k nejake singularite!!! hlasi to radek 3-3...
  - pro ladeni musim doplnit CPrintF
o vubec mi to nenaprogramuje, kdyz zadam radky 1, 2, 3, ale v cache se objevi...
  co s tim???
o ani nehlasi, ze by neco programoval (pocet zmen je stale NULA!)
o taky mi to nesmazalo radek 0...
  budu muset chvili ladit spolu s programovanim PIC z HEX
o vyber fontu pro terminal
o zadavani ^C v rezimu Debug
  ono bude vubec slozite zadavat nektere znaky, ktere jsou dostupne jen pres Alt...
o pouziti prefs.editor a prefs.terminal? (zatim se spousti 'appl' 'LedX')
  pripadne pridat spusteni dalsiho programu...
  mozna by slo jen udelat nastaveni dvou triggeru: Editor, Terminal - ty se pak budou spoustet...
o v popup listech nastavovat spravnou polozku (je to prijemnejsi...)
  file_list -> soubor.bas
  port_list -> <port name> hledat podle port ID
  baud_list -> mit v pameti pole s hodnotama nebo hledat podle StrAToI?
  program_list -> podle retezce...
o kdyz se programoval cely SW znovu, tak to vyhodilo ruzne divne pocty zmen!
  mozna je problem s nacitanim, protoze pokazde tonapsalo jiny pocet radek... 244, 199, 199
  aha, ja uz asi vim, ono tam nebylo nacitani skrytych radku a po naprogramovani se ty radky (asi) odkryly a po dalsim downloadu se nacetly!
  z toho vyplyva, ze by asi defaultne melo byt nacitani skrytych radku zapnute (kvuli tomu, ze originalni SW je obsahuje!)
  ale v mem programu nejsou, tak se uplatni jen pri prvni inicializaci modulu...
o kdyz jsem doplnil hlaseni chyb, tak port zustane otevreny a uz se nikdy nezavre!
o pokud neni zapnuty protikus IrDA, tak nevyhlasi chybu; pri pokusu o Cancel jde do RESETu
  -> budu muset kontrolovat chyby i pri odesilani/prijmu!!!
  - zkusit to odladit na Z22, protoze na Simulatoru se mi nepodarilo zprovoznit IrDA
o zaskrtavatko "Run before debug"
o Update Cache predelat jako Verify
  pri nacitani zaroven probiha porovnani s predchozi verzi cache, pokud je nactena...
  vypise se pocet nactenych radku (uz se vypisuje) a pocet zmenenych radku
-> asi budu muset PPide chvili pouzivat a uvidim...
   ale verifikace by byla moooc uzitecna... Ale je fakt, ze stale nevim, jaky by mel byt vystup
   mozna by zatim stacilo vypsat pocet rozdilnych radku...?
***********************/
// ====================================
// DEBUG functions
// ------------------------------------
// UI debug window
// ------------------------------------
#include <stdarg.h>
static void DEBUG (char *a, ...) {
char *b = MemPtrNew(256);
va_list p;
  va_start(p, a);
  StrVPrintF(b, a, p);
  FrmCustomAlert (show, b, "", "");
  va_end(p);
  MemPtrFree(b);
}
// ------------------------------------
// VFS log
// ------------------------------------
#include <VFSMgr.h>
static FileRef vfsl = 0;
static void VFS_open (void) {
UInt16 volref;
UInt32 voliter;
Err err;
  voliter=vfsIteratorStart;
  while (voliter!=vfsIteratorStop) {
    err=VFSVolumeEnumerate (&volref, &voliter);
    if (err==errNone) break;
  }
  err=VFSFileOpen (volref, "/VFS_log.log", vfsModeCreate | vfsModeWrite, &vfsl);
  if (err!=errNone) vfsl=0;
  else VFSFileSeek (vfsl, vfsOriginEnd, 0);
}
static void VFS_add (char *a, ...) {
char *b = MemPtrNew(256);
va_list p;
  va_start(p, a);
  StrVPrintF(b, a, p);
  if (vfsl) VFSFileWrite (vfsl, StrLen (b), b, NULL);
  va_end(p);
  MemPtrFree(b);
}
static void VFS_close (void) {
  if (vfsl) VFSFileClose (vfsl);
  vfsl=0;
}
// ====================================
// global variables
// ------------------------------------
// application preferences
// ------------------------------------
#define FLAG_HIDDEN     0x00000001
#define FLAG_RUN        0x00000002
#define FLAG_RUN_DOWN   0x00000004
#define FLAG_DBG_OUT    0x00008000
typedef struct {
  UInt32 port;
  UInt32 baud;
  UInt32 flags;
  Char file[dmDBNameLength];
  UInt16 maxline, linestep;
  UInt16 serial_to;
  Char editor[dmDBNameLength];
  FontID font;
} PrefType;
PrefType prefs = {
  0, 19200,
  0,
  //FLAG_HIDDEN,
  {0},
  1021, 5,
  10,
  {"SrcEdit"},
  stdFont
};
// ------------------------------------
// serial devices list
// ------------------------------------
UInt16 port_cnt = 0;
Char **port_name = NULL;
UInt32 *port_ID = NULL;
// ------------------------------------
// cache database
// ------------------------------------
DmOpenRef cacheDB = 0;
// ------------------------------------
// terminal globals
// ------------------------------------
typedef struct {
  UInt16 Y;
  UInt16 X;
  UInt16 COM;
  UInt8 lwdt[128];
  UInt16 lpos;
} globalsType;
globalsType globals = {
  0, 0,
  0,
  {0},
  0
};
// ------------------------------------
// PalmDOC header structure
// ------------------------------------
typedef struct {
  UInt16 version;
  UInt16 zero;
  UInt32 length;
  UInt16 records;
  UInt16 bufsize;
  UInt32 position;
} PalmDocHeader;
// ------------------------------------
// PalmDOC file ref structure
// ------------------------------------
typedef struct {
  DmOpenRef db;
  PalmDocHeader hdr;
  UInt16 actrec;
  UInt16 bufpos;
  UInt16 buflen;
  Char buf[1];
} PalmDocFILE;
// ====================================
// PalmDOC read functions
// ------------------------------------    
// opening PalmDOC file
// ------------------------------------
PalmDocFILE *PalmDocOpen (Char *name) {
DmOpenRef db;
LocalID id;
UInt32 type, crea;
UInt16 bufsize;
MemHandle hndl;
PalmDocHeader *hdr;
PalmDocFILE *f;
  // nejprve databazi najdu
  id=DmFindDatabase (0, name);
  if (!id) return NULL;
  // zkontroluju type a creator
  DmDatabaseInfo (0, id, 0, 0, 0, 0, 0, 0, 0, 0, 0, &type, &crea);
  if (type!='TEXt' || crea!='REAd') return NULL;
  // otevru databazi a nactu hlavicku
  db=DmOpenDatabase (0, id, dmModeReadOnly);
  if (db==NULL) return NULL;
  // nacteni velikosti bufferu
  hndl=DmQueryRecord (db, 0);
  if (hndl==NULL) {
    DmCloseDatabase (db);
    return NULL;
  }
  hdr=MemHandleLock (hndl);
  bufsize=hdr->bufsize;
  f=MemPtrNew (sizeof (PalmDocFILE)+bufsize);
  if (f==NULL) {
    MemHandleUnlock (hndl);
    DmCloseDatabase (db);
    return NULL;
  }
  MemSet (f, sizeof (PalmDocFILE), 0);
  f->db=db;
  MemMove (&f->hdr, hdr, sizeof (PalmDocHeader));
  f->hdr.position=0;
  MemHandleUnlock (hndl);
  return f;
}
// ------------------------------------
// closing PalmDOC file
// ------------------------------------
Err PalmDocClose (PalmDocFILE *f) {
  if (f!=NULL) {
    if (f->db)
      DmCloseDatabase (f->db);
    MemPtrFree (f);
  }
  return 0;
}
// ------------------------------------
// PalmDOC decompress function
// ------------------------------------
static UInt16 PalmDocDecompress (Char *buf, UInt16 buflen, UInt8 *data, UInt16 datalen) {
UInt16 len;
UInt16 i;
Int16 ofs;
  len=0;
  while (datalen && len<buflen) {
    datalen--;
    if (*data>=0xC0) {
      *buf=' ';
      buf++;
      len++;
    }
    if (*data>=0x01 && *data<=0x08) {
      i=*data;
      data++;
      while (i && datalen && len<buflen) {
        *buf=*data;
        buf++;
        data++;
        len++;
        datalen--;
        i--;
      }
    } else
    if (*data>=0x80 && *data<=0xBF) {
      if (!datalen) break;
      ((UInt8*)&i)[0]=*data;
      data++;
      datalen--;
      ((UInt8*)&i)[1]=*data;
      data++;
      ofs=(i>>3)&0x07FF;
      i&=7;
      i+=3;
      while (i && len<buflen) {
        *buf=*(buf-ofs);
        buf++;
        i--;
        len++;
      }
    } else {
      *buf=*data&0x7F;
      buf++;
      data++;
      len++;
    }
  }
  return len;
}
// ------------------------------------
// return remaining data length
// ------------------------------------
UInt16 PalmDocCheckBuf (PalmDocFILE *f) {
MemHandle hndl;
  if (!f) return 0;
  if (!f->db) return 0;
  if (f->bufpos<f->buflen) 
    return (f->buflen-f->bufpos);
  // pokud jsou jeste nejaka data, nactu je
  if (f->actrec>=f->hdr.records)
    return 0;
  f->actrec++;
  hndl=DmQueryRecord (f->db, f->actrec);
  if (hndl==NULL) return 0;
  if (f->hdr.version==1) {
    f->buflen=MemHandleSize (hndl);
    if (f->buflen>f->hdr.bufsize)
      return 0;
    MemMove (f->buf, MemHandleLock (hndl), f->buflen);
    MemHandleUnlock (hndl);
    f->bufpos=0;
    return f->buflen;
  } else
  if (f->hdr.version==2) {
    f->buflen=PalmDocDecompress (f->buf, f->hdr.bufsize, MemHandleLock (hndl), MemHandleSize (hndl));
    MemHandleUnlock (hndl);
    f->bufpos=0;
    return f->buflen;
  }
  return 0; 
}
// ------------------------------------
// read from PalmDOC to application's buffer
// ------------------------------------
Int8 PalmDocEof (PalmDocFILE *f) {
  if (f==NULL) return -1;
  if (f->hdr.position<f->hdr.length) return 0;
  return 1;
}
// ------------------------------------
// read from PalmDOC to application's buffer
// ------------------------------------
UInt16 PalmDocRead (PalmDocFILE *f, Char *buf, UInt16 buflen) {
UInt16 len, i;
  if (f==NULL) return 0;
  len=0;
  while (len<buflen && f->hdr.position<f->hdr.length) {
    i=PalmDocCheckBuf (f);
    if (!i) break;
    if (i>(buflen-len)) i=buflen-len;
    MemMove (buf, &f->buf[f->bufpos], i);
    len+=i;
    f->hdr.position+=i;
    f->bufpos+=i;
  }
  return len;
}
// ------------------------------------
// read one char
// ------------------------------------
Int16 PalmDocGetC (PalmDocFILE *f) {
Char c;
  if (PalmDocRead (f, &c, 1)!=1) return -1;
  return c;
}
// ------------------------------------
// read one line
// ------------------------------------
Char *PalmDocGetS (PalmDocFILE *f, Char *buf, UInt16 buflen) {
UInt16 len;
Char *s;
  s=buf;
  len=0;
  if (!buflen || buf==NULL) return NULL;
  buflen--;
  while (len<buflen) {
    if (PalmDocRead (f, s, 1)!=1) break;
    s++;
    len++;
    if (s[-1]=='\n') break;
  }
  if (!len) return NULL;
  *s=0;
  return buf;
}
// ====================================
// PICputer download functions
// ------------------------------------
// error string function
// ------------------------------------
// nejprve 'chyby' z dialogu, pak chyby z funkci
enum {err_edit=1, err_cancel, err_port, err_send, err_rec, err_flush, err_format, err_compare};
static Char err_str[40];
Char *GetErrString (UInt16 err_no) {
  switch (err_no) {
    case err_port: return "port open";
    case err_send: return "send";
    case err_cancel: return "user cancel";
  }
  StrPrintF (err_str, "unknown (%d)", err_no);
  return err_str;
}
// ------------------------------------
// opening port and preparing PICputer command line
// ------------------------------------
void CPrintF (globalsType *gptr, char *a, ...);
Int16 PortOpen (UInt16 *hCOM, FormPtr frm) {
UInt16 i;
UInt32 size;
Char   buf[3];
Err    err;
  if (!*hCOM)
    if (SrmOpen (prefs.port, prefs.baud, hCOM)!=errNone) {
      if (frm) CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, btn_debug)), 0);
      return err_port;
    }
  if (frm) CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, btn_debug)), *hCOM);
  if (!*hCOM) return err_port;
  // BREAK: ^C
  SrmSend (*hCOM, "\x03", 1, &i);
  if (i!=errNone) return err_send;
  // flushing send & receive FIFOs
  if (SrmReceiveFlush (*hCOM, 10)!=errNone) return err_flush;
  if (SrmSendFlush (*hCOM)!=errNone) return err_flush;
  if (SrmReceiveFlush (*hCOM, 10)!=errNone) return err_flush;
  // flushing PICputer command line
  // sending '\b' until nothing is echoed
  do {
    SrmSend (*hCOM, "\b", 1, &i);
    if (i!=errNone) return err_send;
    size=SrmReceive (*hCOM, buf, 3, prefs.serial_to, &err);
  } while (size && !err);
  
  return 0;
}
// ------------------------------------
// closing port & switching Debug button off
// ------------------------------------
Int16 PortClose (UInt16 *hCOM, FormPtr frm) {
  if (*hCOM) {
    // disable wakeup handler
    SrmSetWakeupHandler (*hCOM, NULL, 0);
    // close port
    SrmClose (*hCOM);
    *hCOM=0;
  }
  if (frm) {
    CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, btn_debug)), 0);
    CtlHideControl (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, btn_break)));
    CtlShowControl (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, btn_run)));
  }
  return 0;
}
// ------------------------------------
// read line from serial interface
// ------------------------------------
Int16 ReadLine (UInt16 hCOM, Char *buf, UInt16 buflen) {
UInt16  pos;
UInt32  size;
Err     err;
  if (buflen) buflen--;
  *buf=0;
  pos=0;
  while (pos<buflen) {
    size=SrmReceive (hCOM, &buf[pos], 1, prefs.serial_to, &err);
    if (!size || err) return -1;
    buf[pos+1]=0;
    if (buf[pos]=='\n') return 0;
    if (!pos && buf[pos]=='>') return -2;
    pos++;
  }
  return 1;
}
// ------------------------------------
// remove CRLF from string
// ------------------------------------
Char *RemoveCRLF (Char *str) {
Char *s;
  s=str;
  while (*s && *s!='\r' && *s!='\n') s++;
  *s=0;
  return str;
}
// ------------------------------------
// compare BASIC lines
// compare ends on '\n' or '\r'
// ------------------------------------
Int16 bascmp (Char *s1, Char *s2) {
Char c1, c2;
  do {
    while (*s1>0 && *s1<=' ') {
      if (*s1=='\n' || *s1=='\r') return 0;
      s1++;
    }
    while (*s2>0 && *s2<=' ') {
      if (*s2=='\n' || *s2=='\r') return 0;
      s2++;
    }
    c1=*s1;
    c2=*s2;
    if (c1>='a' && c1<='z') c1&=~0x20;
    if (c2>='a' && c2<='z') c2&=~0x20;
    if (c1!=c2 || !c1 || !c2) break;
    s1++;
    s2++;
  } while (1);
  if (c1>c2) return 1;
  if (c1<c2) return -1;
  return 0;
}
// ------------------------------------
// execute commands and return read-back or error
// ------------------------------------
Int16 Command (UInt16 hCOM, Char *cmd, Char *resp) {
Err err;
Char str[128], *s;
UInt16 i, lnum;
  SrmSend (hCOM, cmd, StrLen (cmd), &err);
  if (err!=errNone) return err_send;
  SrmSend (hCOM, "\r", 1, &err);
  if (err!=errNone) return err_send;
  // echo
  lnum=StrNCompare (cmd, "clrpgm ", 7)?1:20;
  do {
    i=ReadLine (hCOM, str, 128);
    if (lnum) lnum--;
    if (lnum) SysTaskDelay (10);
  } while (lnum && i);
  if (i) return err_rec;
  // bud ">" nebo error message
  i=ReadLine (hCOM, str, 128);
  if (!i) {
    //asi chyba...
    RemoveCRLF (str);
    if (resp!=NULL) StrCopy (resp, str);
    else DEBUG ("response: %s\n", str);
    // vycteni promptu
    i=ReadLine (hCOM, str, 128);
    //if (!i) return err_rec;
    return err_rec;
  }
  // vycteni zpet do pameti
  if (*cmd>='0' && *cmd<='9' && resp!=NULL) {
    lnum=StrAToI (cmd);
    StrPrintF (str, "li %d %d\r", lnum, lnum);
    SrmSend (hCOM, str, StrLen (str), &err);
    if (err!=errNone) return err_send;
    // echo
    i=ReadLine (hCOM, str, 128);
    if (i) return err_rec;
    // radek programu
    i=ReadLine (hCOM, str, 128);
    if (i) return err_rec;
    // kopie pro tisk/ulozeni
    s=RemoveCRLF (str);
    while (*s>0 && *s<=' ') s++;
    StrCopy (resp, s);
    // vycteni promptu
    i=ReadLine (hCOM, str, 128);
    if (!i) return err_rec;
    // zakladni kontrola
    if (*resp<'0' || *resp>'9') return err_format;
    // kontrola cisla radku
    i=StrAToI (resp);
    if (i!=lnum) return err_compare;
    // radek nekontroluju, protoze vypis muze (?) vypadat trochu jinak (kontrakce, jiny zpusob vypisu...)
    return 0;
  }
  return 0;
}
// ------------------------------------
// progress bar callback function
// ------------------------------------
Boolean progressBar (PrgCallbackDataPtr ptr) {
  StrPrintF (ptr->textP, "%d%%", ptr->stage);
  return true;
}
// ------------------------------------
// add string to cache record
// ------------------------------------
Int16 AddCache (Char *str, UInt16 index) {
MemHandle       hndl;
UInt16          i;
UInt32          pos;
  hndl=DmQueryRecord (cacheDB, index);
  if (!hndl) {
    i=index;
    hndl=DmNewRecord (cacheDB, &i, StrLen (str)+1);
    pos=0;
  } else {
    pos=MemHandleSize (hndl)-1;
    hndl=DmResizeRecord (cacheDB, index, pos+StrLen (str)+1);
    if (hndl)
      hndl=DmGetRecord (cacheDB, index);
  }
  if (hndl) {
    DmWrite (MemHandleLock (hndl), pos, str, StrLen (str)+1);
    MemHandleUnlock (hndl);
    DmReleaseRecord (cacheDB, index, true);
  }
  return 0;
}
// ------------------------------------
// get next cache line
// ------------------------------------
// ------------------------------------
// update cache from module
// ------------------------------------
Int16 UpdateCache (UInt16 *lines, UInt16 *changes) {
UInt16          hCOM;
ProgressPtr     pbd;
UInt16          i, j;
Err             err;
Char            cmd[32];
Char            prog[128];
EventType       event;
UInt16          record;
Char            *s0, *s1;
MemHandle       h0, h1;
  // otevreni serioveho portu
  if (PortOpen (&globals.COM, NULL)) return err_port;
  hCOM=globals.COM;
  // pri vynucenem pozadavku na nacteni smazat obsah cache
  while (DmNumRecords (cacheDB)>1)
    DmRemoveRecord (cacheDB, 1);
  record=DmNumRecords (cacheDB);
  // (znovu)nacteni cache
  pbd=PrgStartDialog ("Creating cache", progressBar, NULL);
  *lines=0;
  err=0;  
  for (i=0; i<=prefs.maxline; i+=prefs.linestep) {
    j=i+prefs.linestep-1;
    if (j>prefs.maxline) j=prefs.maxline;
    PrgUpdateDialog (pbd, 0, (i*100L)/prefs.maxline, "", true);
    // Cancel v Progress dialogu funguje jen kdyz se zpracovavaji eventy...
    EvtResetAutoOffTimer ();
    EvtGetEvent (&event, 0);
    if (!SysHandleEvent (&event))
      if (!FrmDispatchEvent (&event))
        PrgHandleEvent (pbd, &event);
    if (PrgUserCancel (pbd)) {
      while (DmNumRecords (cacheDB)>record)
        DmRemoveRecord (cacheDB, record);
      err=err_cancel;
      break;
    }
    // odeslani prikazu
    StrPrintF (cmd, "li %d %d\r", i, j);
    SrmSend (hCOM, cmd, StrLen (cmd), &err);
    if (err!=errNone) {
      err=err_send;
      break;
    }
    do {
      // nacteni odpovedi
      j=ReadLine (hCOM, prog, 128);
      // ulozeni do souboru
      if (!j && *prog>='0' && *prog<='9') {
	RemoveCRLF (prog);
	StrCat (prog, "\n");
	(*lines)++;
        AddCache (prog, record);
      }
      // pokud obsahuje radek prikaz DATA, pak musim zacit znovu od dalsiho cisla!
      if (StrStr (prog, " DATA ")!=NULL) {
	// nacist cislo radku
	i=StrAToI (prog);
	// pokud mam zobrazovat i skryte radky, tak musim zacit za radkem s timto prikazem
	// pokud je naopak mam preskakovat, musim zacit na radku +<data>+1
	if (prefs.flags&FLAG_HIDDEN) {
	  i-=prefs.linestep-1;
	} else {
	  j=StrAToI (StrStr (prog, " DATA ")+6);
	  i+=j+1-prefs.linestep;
	}
	// zrusit vsechny radky v bufferu a jit znova na nacitani
	do {
	  j=ReadLine (hCOM, prog, 128);
	} while (!j);
      }
    } while (!j);
  }
  if (changes) *changes=0;
  if (DmNumRecords (cacheDB)>1) {
    if (changes && !err) {
      if (prefs.flags&FLAG_DBG_OUT) VFS_open ();
      // signalizace porovnavani
      *changes=1;
      // porovnani stareho i noveho obsahu cache
      h0 = DmQueryRecord (cacheDB, 0);
      h1 = DmQueryRecord (cacheDB, 1);
      if (h0 && h1) {
        s0=MemHandleLock (h0);
        s1=MemHandleLock (h1);
        // algoritmus podobny downloadu
        while (*s0 || *s1) {
          // cisla obou radku
          while (*s0>0 && *s0<=' ') s0++;
          while (*s1>0 && *s1<=' ') s1++;
          i=StrAToI (s0);
          j=StrAToI (s1);
          // progress dialog
/**
          PrgUpdateDialog (pbd, 0, (i*100L)/prefs.maxline, "", true);
          EvtResetAutoOffTimer ();
          EvtGetEvent (&event, 0);
          if (!SysHandleEvent (&event))
            if (!FrmDispatchEvent (&event))
              PrgHandleEvent (pbd, &event);
          if (PrgUserCancel (pbd))
            break;
**/
          // porovnani radku
          if (i==j) {
            j=bascmp (s0, s1);
            //if (bascmp  (s0, s1)) {
            if (j) {
              if (prefs.flags&FLAG_DBG_OUT) VFS_add ("diff: %d (%d) [%c|%c]\r\n", i, j, *s0, *s1);
              (*changes)++;
            }
            j=i;
          } else {
            (*changes)++;
            if (*s0 && *s1) {
              if (prefs.flags&FLAG_DBG_OUT) VFS_add ("diff: %d-%d\r\n", i, j);
            } else
            if (*s0) {
              if (prefs.flags&FLAG_DBG_OUT) VFS_add ("remove: %d\r\n", i);
            } else {
              if (prefs.flags&FLAG_DBG_OUT) VFS_add ("add: %d\r\n", j);
            }
          }
          if (i<=j || !*s1)
            while (*s0 && *s0!='\r' && *s0!='\n') s0++;
          if (i>=j || !*s0)
            while (*s1 && *s1!='\r' && *s1!='\n') s1++;
        }
        MemHandleUnlock (h0);
        MemHandleUnlock (h1);
      }
      VFS_close ();
    }
    // odstraneni predchoziho obsahu cache
    DmRemoveRecord (cacheDB, 0);
  }
  PrgStopDialog (pbd, true);
  SrmClose (hCOM);
  globals.COM=0;
  return err;
}
// ------------------------------------
// smazani radku
// ------------------------------------
// ------------------------------------
// naprogramovani radku
// ------------------------------------
// ------------------------------------
// download file to PICputer module
// ------------------------------------
Int16 Download (Char *file, UInt16 *errpos, UInt16 *changes, Boolean run) {
UInt16          hCOM;
ProgressPtr     pbd;
UInt16          i;
Err             err;
Char            prog[128], line[128], msg[128];
EventType       event;
PalmDocFILE     *f;
MemHandle       hndl;
Char            *s, *ft, *t;
UInt16          tnum, pnum, lnum;
UInt16          edpos;

  if (prefs.flags&FLAG_DBG_OUT) {
    VFS_open ();
    VFS_add ("Download: %s\r\n", file);
  }
  *changes=0;
  // smazat obsah nadbytecnych zaznamu cache
  while (DmNumRecords (cacheDB)>1)
    DmRemoveRecord (cacheDB, 1);
  // kontrola cache
  if (!DmNumRecords (cacheDB)) {
    i=UpdateCache (&tnum, &pnum);
    if (i) return i;
    CPrintF (&globals, "%d lines loaded.\n", tnum);
    if (pnum) CPrintF (&globals, "%d changes found.\n", pnum-1);
  }
  // otevreni serioveho portu
  if (PortOpen (&globals.COM, NULL)) return err_port;
  hCOM=globals.COM;
  // otevreni PalmDOC souboru
  f=PalmDocOpen (file);
  hndl=DmQueryRecord (cacheDB, 0);
  err=0;
  edpos=0;
  *prog=0;
  lnum=0;  
  if (f && hndl) {
    ft=MemHandleLock (hndl);
    pbd=PrgStartDialog ("Processing file", progressBar, NULL);
    while (!PalmDocEof (f)) {
      PrgUpdateDialog (pbd, 0, (f->hdr.position*100L)/f->hdr.length, "", true);
      // Cancel v Progress dialogu funguje jen kdyz se zpracovavaji eventy...
      EvtResetAutoOffTimer ();
      EvtGetEvent (&event, 0);
      if (!SysHandleEvent (&event))
        if (!FrmDispatchEvent (&event))
          PrgHandleEvent (pbd, &event);
      if (PrgUserCancel (pbd)) {
//        while (DmNumRecords (cacheDB))
//          DmRemoveRecord (cacheDB, 0);
        break;
      }
      // nacteni radku ze souboru
      edpos=f->hdr.position;
      if (PalmDocGetS (f, line, 128) == NULL) break;
      s=RemoveCRLF (line);
      while (*s>0 && *s<=' ') s++;
      if (*s==';') continue;
      if (*s>='0' && *s<='9') {
        pnum=StrAToI (s);
        if (lnum && pnum<=lnum) {
          StrPrintF (msg, "Incorrect line numer %d!", pnum);
          err=FrmCustomAlert (error_msg, msg, "", "");            
          if (err) break;
        }
        lnum=pnum;
        if (prefs.flags&FLAG_DBG_OUT) VFS_add ("Processing line %d\r\n", pnum);
        // nactu dalsi radek z TEMPu
        if (!*prog && *ft) {
          t=prog;
          while (*ft!='\n') {
            *t=*ft;
            t++;
            ft++;
          }
          *t=0;
          if (*ft)
            ft++;
          RemoveCRLF (prog);
        }
        t=prog;
        while (*t>0 && *t<=' ') t++;
        if (*t<'0' || *t>'9')
          tnum=pnum;
        else
          tnum=StrAToI (t);
        if (prefs.flags&FLAG_DBG_OUT) VFS_add ("Using temp line %d\r\n", tnum);
        if (pnum>tnum) {
          // pokud nejake radky prebyvaji, tak je musim smazat
          if (prefs.flags&FLAG_DBG_OUT) VFS_add ("Del lines %d-%d\r\n", tnum, pnum-1);
          StrPrintF (prog, "clrpgm %d %d", tnum, pnum-1);
          i=Command (hCOM, prog, NULL);
          if (i) {
            StrPrintF (msg, "Error %d: Unable to delete lines %d-%d!", i, tnum, pnum-1);
            *prog=0;
            err=FrmCustomAlert (error_msg, msg, "", "");            
            if (err) break;
          }
          while (pnum>tnum) {
            (*changes)++;
            t=prog;
            while (*ft!='\n' && *ft) {
              *t=*ft;
              t++;
              ft++;
            }
            *t=0;
            if (*ft)
              ft++;
            t=prog;
            RemoveCRLF (prog);
            while (*t>0 && *t<=' ') t++;
            if (*t<'0' || *t>'9')
              tnum=pnum;
            else
              tnum=StrAToI (t);
            if (prefs.flags&FLAG_DBG_OUT) VFS_add ("Using temp line %d\r\n", tnum);
          }
        }
        if (pnum<tnum) {
          // pokud je pozadovane cislo mensi nez aktualni, ihned programuju
          if (prefs.flags&FLAG_DBG_OUT) VFS_add ("Add line %d\r\n", pnum);
          (*changes)++;
          i=Command (hCOM, line, msg);
          if (i) {
            StrPrintF (line, "Error %d: %s on line %d!", i, msg, pnum);
            err=FrmCustomAlert (error_msg, line, "", "");
            if (err) break;
          } else {
            // porovnani zdrojoveho a vycteneho radku
            if (bascmp (line, msg)) {
              StrPrintF (line, "Different readback on line %d!\n", pnum);
              err=FrmCustomAlert (error_msg, line, "", "");
              if (err) break;
            }
            StrCat (msg, "\n");
            AddCache (msg, 1);
          }
        }
        if (pnum==tnum) {
          // porovnani obsahu
          if (bascmp (s, t)) {
            if (prefs.flags&FLAG_DBG_OUT) VFS_add ("Chng line %d\r\n", pnum);
            (*changes)++;
            i=Command (hCOM, line, msg);
            if (i) {
              StrPrintF (line, "Error %d: %s on line %d!", i, msg, pnum);
              err=FrmCustomAlert (error_msg, line, "", "");
              if (err) break;
            } else {
              // porovnani zdrojoveho a vycteneho radku
              if (bascmp (line, msg)) {
                StrPrintF (line, "Different readback on line %d!\n", pnum);
                err=FrmCustomAlert (error_msg, line, "", "");
                if (err) break;
              }
              StrCat (msg, "\n");
              AddCache (msg, 1);
            }
          } else {
            if (prefs.flags&FLAG_DBG_OUT) VFS_add ("Keep line %d\r\n", pnum);
            StrCat (s, "\n");
            AddCache (s, 1);
          }
          *prog=0;
        }
      } else {
        if (prefs.flags&FLAG_DBG_OUT) VFS_add ("Executing \"%s\"\r\n", prog);
        // posle se primy prikaz
        i=Command (hCOM, s, prog);
        if (i) {
          StrPrintF (msg, "Error %d: %s!", i, prog);
          *prog=0;
          err=FrmCustomAlert (error_msg, msg, "", "");
          if (err) break;
        }
      }
    }
    PrgStopDialog (pbd, true);
    MemHandleUnlock (hndl);
    // pokud doslo k chybe, tak musim zkopirovat zbytek cache zaznamu...
    if (err) {
      // err: 1 - edit
      // err: 2 - cancel
      do {
        if (*prog) {
          StrCat (prog, "\n");
          AddCache (prog, 1);
        }
        t=prog;
        while (*ft!='\n' && *ft) {
          *t=*ft;
          t++;
          ft++;
        }
        *t=0;
        if (*ft)
          ft++;
        RemoveCRLF (prog);
      } while (*prog);
      if (errpos) *errpos=edpos;
      if (err==err_edit) err=-1;
    }
    // presun noveho tempu na aktualni pozici
    if (DmNumRecords (cacheDB)>1)
      DmRemoveRecord (cacheDB, 0);
  }
  if (f) PalmDocClose (f);
  if (!err && run) {
    SrmSend (hCOM, "run\r", 4, &i);
    SysTaskDelay (25);
  }
  SrmClose (hCOM);
  globals.COM=0;
  VFS_close ();
  return err;
}
// ====================================
// console functions
// must not use global variables, because used from callback function
// ------------------------------------
// character output
// ------------------------------------
#define CONSOLE_HEIGHT  130
#define CONSOLE_OFFS_Y  15
void CPutC (globalsType *gptr, Char c) {
RectangleType rect={{0,15},{160,130}};
RectangleType nrec;

  if (c=='\r') {gptr->X=0; gptr->lpos=0; return;}
  if (c=='\n') {gptr->X=0; gptr->lpos=0; gptr->Y+=FntCharHeight (); return;}
// podpora backspace!!!
  if (c=='\b') {
    if (gptr->lpos) gptr->X-=gptr->lwdt[--gptr->lpos];
    return;
  }
// podpora tab???
  if (c>=0 && c<' ') return;
  while (gptr->Y+FntCharHeight ()>=CONSOLE_HEIGHT) {
    WinScrollRectangle (&rect, winUp, FntCharHeight (), &nrec);
    WinEraseRectangle (&nrec, 0);
    gptr->Y-=FntCharHeight ();
  }
  if (gptr->X<160) {
    WinDrawChar (c, gptr->X, gptr->Y+CONSOLE_OFFS_Y);
    if (gptr->lpos<128)
      gptr->X+=gptr->lwdt[gptr->lpos++]=FntCharWidth (c);
  }
}
void CPutS (globalsType *gptr, Char *s) {
  while (*s) {
    CPutC (gptr, *s);
    s++;
  }
}
void CPrintF (globalsType *gptr, char *a, ...) {
char *b = MemPtrNew(256);
va_list p;
  va_start(p, a);
  StrVPrintF(b, a, p);
  CPutS (gptr, b);
  va_end(p);
  MemPtrFree(b);
}
// ------------------------------------
// console serial handler
// must not use global variables!!!
// ------------------------------------
void ConsoleHandler (UInt32 refcon) {
UInt8           *sbuf;
UInt32          len, pos;
  SrmReceiveCheck (((globalsType*)refcon)->COM, &len);
  if (!len) return;
  if (SrmReceiveWindowOpen (((globalsType*)refcon)->COM, &sbuf, &len)!=errNone) return;
  for (pos=0; pos<len; pos++) {
    CPutC (((globalsType*)refcon), sbuf[pos]);
  }
  SrmReceiveWindowClose (((globalsType*)refcon)->COM, pos);
  SrmPrimeWakeupHandler (((globalsType*)refcon)->COM, 1);
}
// ====================================
// main form handler
// ------------------------------------
static Boolean MainFormHandler (EventPtr event) {
FormPtr         frm;
Boolean         handled;
UInt16          i, cnt, j;
void            *tptr;
MemHandle       hndl;
Char            **lstr;
SysDBListItemType *dblist;
GoToParamsType  *param;
Int16           val;
Char            key;

  frm = FrmGetActiveForm ();
  handled=false;
  switch (event->eType) {
    case frmOpenEvent:
      globals.X=globals.Y=0;
      globals.lpos=0;
    case frmUpdateEvent:
      if (*prefs.file) FrmCopyTitle (frm, prefs.file); // FrmSetTitle necha kus stareho textu!!!
      FrmDrawForm (frm);
      break;
/**
    case nilEvent:
      if (!COM) break;
      SrmReceiveCheck (COM, &len);
      if (!len) break;
      if (SrmReceiveWindowOpen (COM, &sbuf, &len)!=errNone) break;
      for (pos=0; pos<len; pos++) {
        CPutC (sbuf[pos]);
      }
      SrmReceiveWindowClose (COM, pos);
      break;
**/
    case menuEvent:
      handled=true;
      MenuEraseStatus (NULL);
      switch (event->data.menu.itemID) {
        case menu_select:
          if (!SysCreateDataBaseList ('TEXt', 'REAd', &cnt, &hndl, false)) break;
          if (!cnt || !hndl) break;
          lstr=MemPtrNew (cnt * sizeof (Char*));
          if (lstr) {
            dblist=MemHandleLock (hndl);
            for (i=0; i<cnt; i++) lstr[i]=dblist[i].name;
            LstSetListChoices (tptr=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, file_list)), lstr, cnt);
            if (*prefs.file)
              for (i=0; i<cnt; i++)
                if (!StrCompare (prefs.file, dblist[i].name)) {
                  LstSetTopItem (tptr, i);
                  break;
                }
            LstSetSelection (tptr, (i<cnt)?i:noListSelection);
            i=LstPopupList (tptr);
            if (i!=(UInt16)-1) {
              StrCopy (prefs.file, lstr[i]);
              // je otevrene menu, tak nemuzu prekreslit form title!!!
              //FrmSetTitle (frm, prefs.file);
              FrmUpdateForm (main_form, 1);
            }
            LstSetListChoices (tptr, NULL, 0);
            MemPtrFree (lstr);
            MemHandleUnlock (hndl);
          }
          MemHandleFree (hndl);
          break;
        case menu_cache:
          if (globals.COM) PortClose (&globals.COM, frm);
          CPrintF (&globals, "Updating cache...\n");
          val=UpdateCache (&i, &cnt);
          if (val)
            CPrintF (&globals, "Update cache: %s error!\n", GetErrString (val));
          else {
            CPrintF (&globals, "%d lines loaded.\n", i);
            if (cnt) CPrintF (&globals, "%d changes found.\n", cnt-1);
          }
          break;
        case menu_about:
          if (FrmCustomAlert (alert_about, build, build_date, build_time)==1)
            FrmHelp (str_about);
          break;
        case menu_setup:
          FrmGotoForm (setup_form);
          break;
        case menu_font:
          prefs.font = FontSelect (prefs.font);
          break;
	default:
	  handled=false;
	  break;
      }
      break;
    case keyDownEvent:
      //switch (event->data.keyDown.chr) {
      if (event->data.keyDown.chr<0x100) {
        if (globals.COM) {
          key=event->data.keyDown.chr;
          if (key=='\n') key='\r';
          SrmSend (globals.COM, &key, 1, &i);
          if (i!=errNone) CPrintF (&globals, "send error!\n");
//        } else {
//          //CPutC (event->data.keyDown.chr);
//          CPrintF (&globals, "key: %04X\n", event->data.keyDown.chr);
        }
      }
      break;
    case ctlSelectEvent:
      switch (event->data.ctlSelect.controlID) {
        case btn_download:
          cnt=0;
          if (globals.COM) PortClose (&globals.COM, frm);
          CPrintF (&globals, "Processing %s...\n", prefs.file);
          val=Download (prefs.file, &i, &j, (prefs.flags&FLAG_RUN_DOWN)!=0);
          if (!val || j)
            CPrintF (&globals, "%d changes made.\n", j);
          if (val<0) goto launch_editor_goto;
          if (val) CPrintF (&globals, "Download: %s error!\n", GetErrString (val));
          break;
        case btn_edit:
          i=0;
          cnt=-1;
        launch_editor_goto:
          // volani editoru - zatim podporuju jen SrcEdit
          // SrcEdit ma nejaky zpusob volani compileru pro par pripon, mozna by sel upravit pro .bas - UPRAVENO!
          // pokud neni zadny vybrany soubor, tak se spusti editor normalne, jinak se mu podstrci vybrany soubor
          // zatim bez souboru koncim...
          if (!*prefs.file) break;
          // vytvoreni bloku parametru
          param = MemPtrNew (sizeof (GoToParamsType));
          MemPtrSetOwner (param, 0);
          // nastaveni souboru
          param->dbCardNo = 0;
          param->dbID = DmFindDatabase (0, prefs.file);
          // nastaveni pozice v souboru
          param->searchStrLen = cnt;
          param->matchPos = i;
          param->matchFieldNum = 0;

          // pokus s oznacenim chyby
          //param->searchStrLen = 9; // delka selekce
          //param->matchPos = 0x62E; // pozice v nekomprimovanem souboru

          // custom polozka
          param->matchCustom = 0;
          // spusteni editoru
          {
            DmSearchStateType search;
            LocalID locid;
            if (!(locid=DmFindDatabase (0, prefs.editor)))
              if (DmGetNextDatabaseByTypeCreator (true, &search, 'appl', 'LedX', true, &i, &locid)!=errNone)
                locid=0;
            if (locid)
              SysUIAppSwitch (0, locid, sysAppLaunchCmdGoTo, param);
            else
              MemPtrFree (param);
          }
          break;
        case btn_run:
          if (!PortOpen (&globals.COM, frm)) {
            SrmSend (globals.COM, "run\r", 4, &i);
            if (i!=errNone)
              CPrintF (&globals, "send error!\n");
            else
              SysTaskDelay (25);
          } else
            CPrintF (&globals, "port error!\n");
          PortClose (&globals.COM, frm);
          break;
        case btn_debug:
          if (event->data.ctlSelect.on) {
            if (PortOpen (&globals.COM, frm)) {
              CPrintF (&globals, "port error!\n");
              PortClose (&globals.COM, frm);
              break;
            }
            SrmSetWakeupHandler (globals.COM, &ConsoleHandler, (UInt32)&globals);
            SrmPrimeWakeupHandler (globals.COM, 1);
            // if requested, send run command
            if (prefs.flags&FLAG_RUN)
              SrmSend (globals.COM, "run\r", 4, &i);
            else
              // send ENTER to show line prompt
              SrmSend (globals.COM, "\r", 1, &i);
            if (i!=errNone) CPrintF (&globals, "send error!\n");
            CtlHideControl (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, btn_run)));
            CtlShowControl (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, btn_break)));
          } else {
            PortClose (&globals.COM, frm);
          }
          break;
        case btn_break:
          if (globals.COM) {
            SrmSend (globals.COM, "\x03", 1, &i);
            if (i!=errNone) CPrintF (&globals, "send error!\n");
          }
          break;
      }
      break;
    default:
      break;
  }
  return handled;
}
// ====================================
// setup form handler
// ------------------------------------
static Boolean SetupFormHandler (EventPtr event) {
FormPtr         frm;
Boolean         handled;
UInt16          i, cnt;
void            *tptr;
MemHandle       hndl;
Char            sval[16];
Char            **lstr;
SysDBListItemType *dblist;

  frm = FrmGetActiveForm ();
  handled=false;
  switch (event->eType) {
    case frmOpenEvent:
      // hledani odpovidajiciho nazvu
      LstSetListChoices (tptr=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, port_list)), port_name, port_cnt);
      for (i=0; i<port_cnt; i++) {
        if (prefs.port==port_ID[i]) {
          CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, port_trig)), port_name[i]);
          LstSetTopItem (tptr, i);
          break;
        }
      }
      LstSetSelection (tptr, (i<port_cnt)?i:noListSelection);
      cnt = LstGetNumberOfItems (tptr = FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, baud_list)));
      for (i=0; i<cnt; i++) {
        if (prefs.baud == StrAToI (LstGetSelectionText (tptr, i))) {
          CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, baud_trig)), LstGetSelectionText (tptr, i));
          LstSetTopItem (tptr, i);
          break;
        }
      }
      LstSetSelection (tptr, (i<cnt)?i:noListSelection);
      CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, read_hidden)), (prefs.flags&FLAG_HIDDEN)!=0);
      CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, run_debug)), (prefs.flags&FLAG_RUN)!=0);
      CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, run_download)), (prefs.flags&FLAG_RUN_DOWN)!=0);
      CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, debug_output)), (prefs.flags&FLAG_DBG_OUT)!=0);
      StrPrintF (sval, "%d", prefs.linestep);
      FldInsert (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, line_step)), sval, StrLen (sval));
      StrPrintF (sval, "%d", prefs.maxline);
      FldInsert (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, line_count)), sval, StrLen (sval));
      StrPrintF (sval, "%d", prefs.serial_to);
      FldInsert (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, timeout)), sval, StrLen (sval));
      if (*prefs.editor) CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, editor_trig)), prefs.editor);
      //if (*prefs.terminal) CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, terminal_trig)), prefs.terminal);
      // jen pri spusteni na OS5...
      //FrmSetNavState (frm, kFrmNavStateFlagsObjectFocusMode);
    case frmUpdateEvent:
      FrmDrawForm (frm);
      break;
    case frmCloseEvent:
      prefs.flags=0;
      if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, read_hidden)))) prefs.flags|=FLAG_HIDDEN;
      if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, run_debug)))) prefs.flags|=FLAG_RUN;
      if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, run_download)))) prefs.flags|=FLAG_RUN_DOWN;
      if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, debug_output)))) prefs.flags|=FLAG_DBG_OUT;
      hndl=FldGetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, line_step)));
      if (hndl) {
        prefs.linestep=StrAToI (MemHandleLock (hndl));
        MemHandleUnlock (hndl);
      }
      hndl=FldGetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, line_count)));
      if (hndl) {
        prefs.maxline=StrAToI (MemHandleLock (hndl));
        MemHandleUnlock (hndl);
      }
      hndl=FldGetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, timeout)));
      if (hndl) {
        prefs.serial_to=StrAToI (MemHandleLock (hndl));
        MemHandleUnlock (hndl);
      }
      break;
/**
    case menuEvent:
      handled=true;
      MenuEraseStatus (NULL);
      switch (event->data.menu.itemID) {
	default:
	  handled=false;
	  break;
      }
      break;
**/
/**
    case keyDownEvent:
      //switch (event->data.keyDown.chr) {
      break;
**/
    case ctlSelectEvent:
      switch (event->data.ctlSelect.controlID) {
        case btn_OK:
          FrmGotoForm (main_form);
          break;
        case editor_trig:
        //case terminal_trig:
          if (!SysCreateDataBaseList ('appl', 0, &cnt, &hndl, false)) break;
          if (cnt && hndl) {
            lstr=MemPtrNew (cnt * sizeof (Char*));
            if (lstr) {
              dblist=MemHandleLock (hndl);
              for (i=0; i<cnt; i++) lstr[i]=dblist[i].name;
              LstSetListChoices (tptr=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, program_list)), lstr, cnt);
              if (*prefs.editor)
                for (i=0; i<cnt; i++)
                  if (!StrCompare (prefs.editor, dblist[i].name)) {
                    LstSetTopItem (tptr, i);
                    break;
                  }
              LstSetSelection (tptr, (i<cnt)?i:noListSelection);
              i=LstPopupList (tptr);
              if (i!=(UInt16)-1) {
                //CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, event->data.ctlSelect.controlID)), StrCopy ((event->data.ctlSelect.controlID==editor_trig)?prefs.editor:prefs.terminal, lstr[i]));
                CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, event->data.ctlSelect.controlID)), StrCopy (prefs.editor, lstr[i]));
              }
              LstSetListChoices (tptr, NULL, 0);
              MemPtrFree (lstr);
              MemHandleUnlock (hndl);
            }
          }
          if (hndl) MemHandleFree (hndl);
          handled = true;
          break;
      }
      break;
    case popSelectEvent:
      switch (event->data.popSelect.listID) {
        case port_list:
          prefs.port=port_ID[event->data.popSelect.selection];
          break;
        case baud_list:
          prefs.baud=StrAToI (LstGetSelectionText (event->data.popSelect.listP, event->data.popSelect.selection));
          break;
      }
      break;
    default:
      break;
  }
  return handled;
}
// ====================================
// basic application functions
// ------------------------------------    
// startup setup
// ------------------------------------
static Err StartApplication(void) {
UInt16          i;
DeviceInfoType  info;
LocalID         locid;

  // load application preferences
  i=0;
  if (PrefGetAppPreferences (AppID, 0, NULL, &i, true)!=noPreferenceFound) {
    if (i>sizeof (prefs)) i=sizeof (prefs);
    PrefGetAppPreferences (AppID, 0, &prefs, &i, true);
  }
  // load serial port names
  SrmGetDeviceCount (&port_cnt);
  for (i=0; i<port_cnt; i++) {
    SrmGetDeviceInfo (i, &info);
  }
  port_name = MemPtrNew (port_cnt * sizeof (Char*));
  if (port_name == NULL) return cantRunApp;
  port_ID = MemPtrNew (port_cnt * sizeof (UInt32));
  if (port_ID == NULL) return cantRunApp;
  for (i=0; i<port_cnt; i++) {
    SrmGetDeviceInfo (i, &info);
    port_name[i]=info.serDevPortInfoStr;
    port_ID[i]=info.serDevCreator;
  }
  // open cache database
  locid = DmFindDatabase (0, "PP_IDE_cache");
  if (!locid) {
    if (DmCreateDatabase (0, "PP_IDE_cache", AppID, 'TEMP', false)!=errNone) return cantRunApp;
    locid = DmFindDatabase (0, "PP_IDE_cache");
    if (!locid) return cantRunApp;
    i=dmHdrAttrBackup;
    DmSetDatabaseInfo (0, locid, NULL, &i, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
  }
  cacheDB = DmOpenDatabase (0, locid, dmModeReadWrite);
  if (!cacheDB) return cantRunApp;
  return 0;
}
// ------------------------------------
// exit cleanup
// ------------------------------------
static void StopApplication (Err code) {
  if (globals.COM) SrmClose (globals.COM);
  if (cacheDB) DmCloseDatabase (cacheDB);
  if (port_ID!=NULL) MemPtrFree (port_ID);
  if (port_name!=NULL) MemPtrFree (port_name);
  PrefSetAppPreferences (AppID, 0, 0, &prefs, sizeof (prefs), true);
  VFS_close ();
}
// ------------------------------------
// event loop
// ------------------------------------
static void EventLoop(void) {
FormPtr         form;
EventType       event;
UInt16          err;

  do {
    EvtGetEvent (&event, evtWaitForever);
    //EvtGetEvent (&event, (globals.COM)?0:evtWaitForever);
    if (SysHandleEvent (&event)) continue;
    if (MenuHandleEvent (NULL, &event, &err)) continue;
    if (event.eType == frmLoadEvent) {
      FrmSetActiveForm (form=FrmInitForm (event.data.frmLoad.formID));
      switch (event.data.frmLoad.formID) {
	case main_form:
	  FrmSetEventHandler (form, (FormEventHandlerPtr) MainFormHandler);
	  break;
	case setup_form:
	  FrmSetEventHandler (form, (FormEventHandlerPtr) SetupFormHandler);
	  break;
      }
    }
    if (FrmDispatchEvent (&event)) continue;
  } while (event.eType != appStopEvent);
  FrmCloseAllForms ();
}
// ------------------------------------
// application entry point
// ------------------------------------
UInt32  PilotMain (UInt16 cmd, void *cmdPBP, UInt16 launchFlags) {
Err             error;

  if (cmd!=sysAppLaunchCmdNormalLaunch)
    return 0;
  // application start-up part
  if ((error=StartApplication ())) {
    FrmAlert (error);
    StopApplication (error);
    return error;
  }
  // display main form
  FrmGotoForm (main_form);
//  FrmGotoForm (setup_form);
  // event loop
  EventLoop ();
  // application end routine
  StopApplication (0);
  return 0;
}
